function [] = driver_lu
% DRIVER_LU driver per la risoluzione di A*x = b tramite l'algoritmo di
% eliminazione di Gauss e la fattorizzazione LU con e senza pivoting.

A = rand(10,10); A(1,1)=1e-15;
b = A*ones(10,1);
[L,U,y] = fatt_LU(A,b);
[L,U,P,y] = fatt_LU_pivot(A,b);
norm(P*A-L*U)

% algortimo di sostituzione all'indietro
n = size(A,1);
x(n) = y(n)/U(n,n);

for i = n-1:-1:1
    s = 0;
    for j=i+1:n
        s = s + U(i,j)*x(j);
    end
    x(i) = (y(i)-s)/U(i,i);
end
norm(x'-ones(10,1))
x
end