function [L,U,y] = fatt_LU(A,b)
%FATT_LU esegue la fattorizzazione LU della matrice A (senza pivoting)
%           A = L*U
%   INPUT: - A matrice dei coefficienti
%          - b vettore dei termini noti
%   OUTPUT: - L matrice triangolare inferiore a diagonale unitaria
%           - U matrice triangolare superiore
%           - y vettore tale che U*x = y (x soluzione di A*x =b)

n=size(A,1);
I = eye(n); LL = zeros(n); 

for k = 1:n-1
    l(1:k,:)=0;
    for i = k+1:n
        l(i,:) = A(i,k)/A(k,k); % vettore l_k
    end
    e = zeros(n,1); e(k,1) = 1; % vettore base canonica
    L = I-l*e'; % matrice L_k
    A = L*A; b = L*b;  % aggiornamento A e b
    LL = l*e' + LL;
end

U=A; L=I+LL; y =b;
end