function [L,U,P,y] = fatt_LU_pivot(A,b)
%FATT_LU_PIVOT esegue la fattorizzazione LU della matrice A (con pivoting
% parziale)
%           P*A = L*U
%   INPUT: - A matrice dei coefficienti
%          - b vettore dei termini noti
%   OUTPUT: - L matrice triangolare inferiore a diagonale unitaria
%           - U matrice triangolare superiore
%           - P matrice di permutazioni
%           - y vettore tale che U*x = y (x soluzione di A*x =b)

n=size(A,1);
I = eye(n);   IL = I; PP=I;

for k = 1:n-1
    P=I;
    [row,~] = find(abs(A(k:end,k)) == max(abs(A(k:end,k))));
    pivot=k-1+row;
    Pold = P(k,:); P(k,:) = P(pivot,:); P(pivot,:)= Pold;
    A = P*A; b = P*b; 
    PP = P*PP;
    l(1:k,:)=0;
    for i = k+1:n
        l(i,:) = A(i,k)/A(k,k); % vettore l_k
    end
    e = zeros(n,1); e(k,1) = 1; % vettore base canonica
    L = I-l*e'; % matrice L_k
    A = L*A; b = L*b;  % aggiornamento A e b
    IL = P*IL*P*(I +l*e');
end

U=A; L=IL; y =b; P = PP;
end